-- Other mods might have put lamps in a different fast-replacable group or
-- changed their collision box.  In case they did, here we'll change the flip
-- dots to match whatever the lamps have become.

data.raw["lamp"]["lamp-flip-dot"].collision_box = data.raw.lamp["small-lamp"].collision_box
data.raw["lamp"]["lamp-flip-dot"].collision_mask = data.raw["lamp"]["small-lamp"].collision_mask
data.raw["lamp"]["lamp-flip-dot"].fast_replaceable_group = data.raw.lamp["small-lamp"].fast_replaceable_group

data.raw["power-switch"]["switch-flip-dot"].collision_box = data.raw["lamp"]["small-lamp"].collision_box
data.raw["power-switch"]["switch-flip-dot"].collision_mask = data.raw["lamp"]["small-lamp"].collision_mask
data.raw["power-switch"]["switch-flip-dot"].fast_replaceable_group = data.raw["lamp"]["small-lamp"].fast_replaceable_group

-- They also might have based a new entity on the lamp after we added the
-- next_upgrade, but chosen a different collision box.  Here we'll check
-- everything and make sure it isn't set to upgrade to a flip-dot despite not
-- being the same size as a flip dot.

for ko, vo in pairs(data.raw) do
  for k, v in pairs(vo) do
   if (v.next_upgrade == "lamp-flip-dot" or v.next_upgrade == "switch-flip-dot") then
     if v.collision_box ~= data.raw["lamp"]["small-lamp"].collision_box then
       print (string.format("flip-dots: removing next_upgrade = %s from %s to prevent an error", v.next_upgrade, k))
       v.next_upgrade = nil
     end
   end
 end
end

log(serpent.block(data.raw["lamp"]["small-lamp"].collision_mask))
log(serpent.block(data.raw["lamp"]["lamp-flip-dot"].collision_mask))
log(serpent.block(data.raw["power-switch"]["switch-flip-dot"].collision_mask))
