local lamp_entity = table.deepcopy(data.raw["lamp"]["small-lamp"])
data.raw.lamp["small-lamp"].next_upgrade = "lamp-flip-dot"

lamp_entity.name = "lamp-flip-dot"
lamp_entity.minable.result = "lamp-flip-dot"
lamp_entity.darkness_for_all_lamps_on = 1.0
lamp_entity.darkness_for_all_lamps_off = 1.0
lamp_entity.light.intensity = 0.0
lamp_entity.light_when_colored.intensity = 0.0
lamp_entity.glow_size = 0
lamp_entity.next_upgrade = "small-lamp"
lamp_entity.selection_box = {{-0.50, -1.0}, {0.50, 0.50}}
lamp_entity.collision_box = data.raw["lamp"]["small-lamp"].collision_box
lamp_entity.collision_mask = data.raw["lamp"]["small-lamp"].collision_mask

lamp_entity.picture_off =
{
  layers =
  {
    {
      filename = "__flip-dots__/box.png",
      priority = "high",
      width = 64,
      height = 64,
      frame_count = 1,
      axially_symmetrical = false,
      direction_count = 1,
      shift = util.by_pixel(8,-8),
      hr_version =
      {
        filename = "__flip-dots__/hr-box.png",
        priority = "high",
        width = 128,
        height = 128,
        frame_count = 1,
        axially_symmetrical = false,
        direction_count = 1,
        shift = util.by_pixel(8,-8),
        scale = 0.5
      }
    },
    {
      filename = "__flip-dots__/shadow.png",
      priority = "high",
      width = 64,
      height = 64,
      frame_count = 1,
      axially_symmetrical = false,
      direction_count = 1,
      shift = util.by_pixel(8,-8),
      draw_as_shadow = true,
      hr_version =
      {
        filename = "__flip-dots__/hr-shadow.png",
        priority = "high",
        width = 128,
        height = 128,
        frame_count = 1,
        axially_symmetrical = false,
        direction_count = 1,
        shift = util.by_pixel(8,-8),
        draw_as_shadow = true,
        scale = 0.5
      }
    }
  }
}

lamp_entity.picture_on =
{
  filename = "__flip-dots__/dot.png",
  priority = "high",
  width = 64,
  height = 64,
  frame_count = 1,
  axially_symmetrical = false,
  direction_count = 1,
  shift = util.by_pixel(8,-8),
  hr_version =
  {
    filename = "__flip-dots__/hr-dot.png",
    priority = "high",
    width = 128,
    height = 128,
    frame_count = 1,
    axially_symmetrical = false,
    direction_count = 1,
    shift = util.by_pixel(8,-8),
    scale = 0.5
  }
}

lamp_entity.signal_to_color_mapping =
{
  {type = "virtual", name = "signal-red",    color = {r = 1, g = 0.1, b = 0.0}},
  {type = "virtual", name = "signal-green",  color = {r = 0.2, g = 1, b = 0.0}},
  {type = "virtual", name = "signal-blue",   color = {r = 0.0, g = 0.5, b = 1}},
  {type = "virtual", name = "signal-yellow", color = {r = 1, g = 1, b = 0.0}},
  {type = "virtual", name = "signal-pink",   color = {r = 1, g = 0.0, b = 0.5}},
  {type = "virtual", name = "signal-cyan",   color = {r = 0.0, g = 1, b = 0.5}},
  {type = "virtual", name = "signal-white",  color = {r = 1, g = 1, b = 1}},
  {type = "virtual", name = "signal-grey",   color = {r = 0.4, g = 0.5, b = 0.6}},
  {type = "virtual", name = "signal-black",  color = {r = 1.0, g = 0.5, b = 0.0}},
}

lamp_entity.icon = "__flip-dots__/lamp-icon.png"
lamp_entity.icon_size = 64

lamp_entity.fast_replaceable_group = data.raw.lamp["small-lamp"].fast_replaceable_group

local lamp_item = table.deepcopy(data.raw["item"]["small-lamp"])

lamp_item.name = "lamp-flip-dot"
lamp_item.icon = "__flip-dots__/lamp-icon.png"
lamp_item.icon_size = 64
lamp_item.order = "a[light]-a[small-lamp]_a"
lamp_item.place_result = "lamp-flip-dot"
lamp_item.stack_size = 50

local lamp_recipe = table.deepcopy(data.raw["recipe"]["small-lamp"])

lamp_recipe.enabled = true
lamp_recipe.name = "lamp-flip-dot"
lamp_recipe.ingredients = {
  {type = "item", name = "wooden-chest", amount = 1},
  {type = "item", name = "electric-engine-unit", amount = 1},
  {type = "item", name = "coal", amount = 1},
  {type = "item", name = "small-lamp", amount = 1}
}
lamp_recipe.results = {
  {type = "item", name = "lamp-flip-dot", amount = 1}
}

data:extend{lamp_entity, lamp_item, lamp_recipe}
